#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include "SArandom.h"
#include "calloc.h"

#ifndef __LOCAL_SA__

#define MACHINE_PRECISION       1.4e-17         /* SUN4 */
#define TRUE                    1
#define FALSE                   0
#define MAXIMUM_MODES           10
#define TO_FILE                 1
#define TO_SCREEN               2
#define DEV_NULL                "/dev/null"    
#define NO_OUTPUT               3
#define PI                      3.141592653589793L
#define MAXIMUM_LENGTH_FILENAME 100


#define SQR(a)            ((a)*(a))


#define __LOCAL_SA__

#endif




/**************/
/* PROTOTYPES */
/**************/
void   SA(int, char **);

void   CopyVector(double *, double *, int);
double RandomSA(double *);
void   PrintSAParameters(double *, double *, int, double *,
			 double *, double ,
			 int, double, double, double, int, int,
			 double, double, double, double, char *,
			 double, int, double, double, char *,
			 int, int, int, int, int, int, int,
			 int, int, int, int, int, int, int,
			 double ,double, int, int ,int ,int,double);
FILE   *OpenFile(char *, char *);
FILE   *OpenOutputDevice(char *, char *, int);
void   FScanColon(FILE *);
int    CheckMode(int, char *);

int    Accept(int, double, double, double,double,double);
int    MetropolisAcceptanceCriterium(double, double, double);
int    SigmoideAcceptanceCriterium(double, double, double);
int    GSAAcceptanceCriterium(double, double, double, double);

void   Heating(int);
void   HeatingGeometric(double *, double *, int, double, double, 
			int, int, int, double, double);
void   HeatingSetConstant(double);

void   DecrementControlParameter(int);
void   DecrementControlParameterDynamicGeometric(double *, double, double);
void   DecrementControlParameterGeometric(double *, double);
void   DecrementControlParameterGeometric2(double *, double, int);
void   DecrementControlParameterLinear(double *, double);
void   DecrementControlParameterLogarithmic(double *, double, int);
void   DecrementControlParameterExponential(double *, double, double, int);

void   Initialize(char **, int, char **, double **, double **, double **,
		  double **, double **, double **, double **, 
                  int *, double *,
		  int *, double *, double *, double *, int *, int *,
		  double *, double *, double *, double *, char *,
		  double *, int *, double *, double *, char *,
		  int *, int *, int *, int *, int *, int *,
		  int *, int *, int *, int *, int *, int *, int *, int *,
		  double *, double *, int *, int *, int *, int *, double *);
void   InitializeParameters(double *, double *, double *, double *, 
			    double *, int);

void   GenerateNewParametersUniform(double *, double *, double *, 
				    double *, int, double);
void   GenerateNewParametersCauchy(double *, double *, double *, 
				   double *, int, double);
void   GenerateNewParametersGauss(double *, double *,double *,
				  double *, int, double);
void   SetNewParameters(int, double, double *, double *, double *,
			double *, int);

double AcceptanceRatio(int, int);

int    ExitMarkovChain(char *);
int    ExitMarkovChainMaximumTransitions(int, int);
int    ExitMarkovChainNumberOfTransistions(int, int);
int    ExitMarkovChainMinimumRejections(int, int);
int    ExitMarkovChainFunctionValues(double *, int, int);

int    ExitSimulatedAnnealing(char *);
int    ExitSimulaatedAnnealingMachinePrecision(double, double);
int    ExitSimulaatedAnnealingMinimumCostFunction(double, double);
int    ExitSimulatedAnnealingControlParameter(double, double);
int    ExitSimulatedAnnealingAcceptation(int, int, double);
int    ExitSimulatedAnnealingFunctionValues(double *, int, int);



/****************************************************************/
/* the next two function must be defined by the user in his own */
/* module.                                                      */
/****************************************************************/
extern double EvaluateCostFunction (int, double *);
extern void   GenerateNewParametersUser(double *, double *, double *,
					double *, int, double);




