#include <stdio.h>
#include <math.h>
#include <stdlib.h>

#include "calloc.h"
#include "SArandom.h"

double EvaluateCostFunction (int, double *);
void   GenerateNewParametersUser(double *, double *,double *,
				 double *, int, double);
void   Main                 (int, char **);



void main (int argc, char *argv[]) 
{
 SA(argc, argv);
}


double EvaluateCostFunction (int     NumberOfParameters,
			     double *ParamValues)

{
 int i;
 double Error;

 Error=0.0;
 for(i=0;i<NumberOfParameters;i++)
   Error += ParamValues[i]*ParamValues[i];

 return(Error);
}

   

void GenerateNewParametersUser (double *ParametersNew, 
				double *Parameters,
				double *UpperBounds,
				double *LowerBounds,
				int     NumberOfParameters,
				double  ControlParameter)

/* bounds are not checked ! */
{
 int i;
 double x1,x2, RandomFraction, Sum, *Direction, StepSize;

 CALLOC1D(Direction,NumberOfParameters);

 StepSize=0.05;

 Sum=0.0;
 for(i=0;i<NumberOfParameters;i++) {
   SA_StandardGauss0(&x1,&x2,&RandomFraction);
   Direction[i]=x1;
   Sum += x1*x1;
 }

 for(i=0;i<NumberOfParameters;i++) 
   ParametersNew[i]= Parameters[i] + StepSize * Direction[i]/sqrt(Sum);
 
 FREE1D(Direction);
} 

